function [y2] = spline(x,y,N,yp1,ypn)

cutoff = 0.99*10^30;

if (yp1 > cutoff)
  y2(1,1) = 0.;
   u(1,1) = 0.;
elseif (yp1 <= cutoff)
  y2(1,1) = 0.5;
   u(1,1) = ( 3.0/(x(2,1) - x(1,1)) ) * ( (y(2,1)-y(1,1))/(x(2,1)-x(1,1)) - yp1);
end

for i=2:N-1
    sig =  ( x(i,1) - x(i-1,1) ) / ( x(i+1,1) - x(i,1)) ;
      p = sig * y2(i-1,1) + 2;
  y2(i,1) = (sig-1.0)/p;
   u(i,1) = (6.0 * ( (y(i+1,1)-y(i,1))/(x(i+1,1)-x(i,1)) - (y(i,1)-y(i-1,1)) / (x(i,1) - x(i-1,1)))/(x(i+1,1)-x(i-1,1))-sig*u(i-1,1))/p;
end

if (ypn > cutoff)
     qn = 0.0;
     un = 0.0;
elseif (ypn <= cutoff)
     qn = 0.5;
     un = (3.0 /(x(N,1)-x(N-1,1))) * (ypn- (y(N,1)-y(N-1,1))/(x(N,1)-x(N-1,1)));
end
y2(N,1) = (un - qn*u(N-1,1) )/(qn*y2(N-1,1)+1.0);
for i = 1:N-1
    k = N - i;
    y2(k,1) = y2(k,1)*y2(k+1,1) + u(k,1);
end
